/***************************************************************************
                           elementcommander.h
                           version 0.5.3 $Revision: 1.11 $
                           -------------------------------
    copyright            : (C) 1999-2003 by Stefan Preis
                         : (C) 2004-2008 Guido Scholz
    email                : guido.scholz@bayernline.de
    last modified        : $Date: 2009-10-26 21:59:44 $
***************************************************************************/

/**************************************************************************
 *                                                                        *
 *   This program is free software; you can redistribute it and/or modify *
 *   it under the terms of the GNU General Public License as published by *
 *   the Free Software Foundation; either version 2 of the License, or    *
 *   (at your option) any later version.                                  *
 *                                                                        *
 **************************************************************************/

/**************************************************************************
   this is the header file to elementcommander.cpp
 **************************************************************************/

#ifndef ELEMENTCOMMANDER_H
#define ELEMENTCOMMANDER_H

#include <QGroupBox>
#include <QDialog>
#include <QHBoxLayout>
#include <QLabel>
#include <QPixmap>
#include <QPushButton>
#include <QToolTip>



class elementCommander: public QDialog
{
   Q_OBJECT

public:
   elementCommander(QWidget* parent = 0, int = 0);

private:
   void setupBridge();                // sets up the bridge buttons
   void setupMotor();                 // sets up the motor buttons

private slots:
   void slotMoveUp();                 // moves bridge up
   void slotMoveDown();               // moves bridge down
   void slotRotateLeft();             // rotates motor left
   void slotRotateRight();            // rotates motor right
   void slotStop();                   // stop any movements

signals:
   void sendTtCommand(int, int);       // sends keys to element

private:
   QPushButton*  buttMoveUp;          // button for moving a bridge up
   QPushButton*  buttMoveDown;        // button for moving a bridge down
   QPushButton*  buttRotateLeft;      // button for rotating a motor cw
   QPushButton*  buttRotateRight;     // button for rotating a motor acw
   QPushButton*  buttStop;            // button for stop any movements
   QPixmap       pixButton;           // the pixmap for each button
   QGroupBox*    buttonGB;            // moving/rotating
   QHBoxLayout *hbox;
   int classid;
};

#endif
