/*
 * paintitemwindow.cpp
 * -------------------
 * Copyright    : (C) 2007 by Guido Scholz
 * E-Mail       : guido.scholz@bayernline.de
 * Begin        : 2007-09-26
 * Last modified: $Date: 2009-03-16 17:38:04 $
 *                $Revision: 1.19 $
 *
 * This code creates a dockable window with a set of paint items 
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qbuttongroup.h>

#include "paintitembutton.h"
#include "paintitemwindow.h"

/*straight track panels*/
#include "pixmaps/spdritem_dil.xpm"
#include "pixmaps/spdritem_dir.xpm"
#include "pixmaps/spdritem_krh.xpm"
#include "pixmaps/spdritem_krl.xpm"
#include "pixmaps/spdritem_krr.xpm"
#include "pixmaps/spdritem_tdb.xpm"
#include "pixmaps/spdritem_tdl.xpm"
#include "pixmaps/spdritem_tdr.xpm"
#include "pixmaps/spdritem_trh.xpm"
#include "pixmaps/spdritem_trv.xpm"
#include "pixmaps/spdritem_tuh.xpm" //tug
#include "pixmaps/spdritem_tuv.xpm"
#include "pixmaps/spdritem_tul.xpm"
#include "pixmaps/spdritem_tur.xpm"

/*curved track panels*/
#include "pixmaps/spdritem_cl3.xpm"
#include "pixmaps/spdritem_cl1.xpm"
#include "pixmaps/spdritem_cr1.xpm"
#include "pixmaps/spdritem_cr3.xpm"
#include "pixmaps/spdritem_cl4.xpm"
#include "pixmaps/spdritem_cr4.xpm"
#include "pixmaps/spdritem_cl2.xpm"
#include "pixmaps/spdritem_cr2.xpm"

/*switch panels */
#include "pixmaps/spdritem_tl1.xpm" //wel
#include "pixmaps/spdritem_tl3.xpm"
#include "pixmaps/spdritem_tr1.xpm" //wer
#include "pixmaps/spdritem_tr3.xpm"
#include "pixmaps/spdritem_dbl.xpm" //dwl
#include "pixmaps/spdritem_dbr.xpm"
#include "pixmaps/spdritem_dtr.xpm" //dwr
#include "pixmaps/spdritem_dtl.xpm"
#include "pixmaps/spdritem_syr.xpm" //wey
#include "pixmaps/spdritem_syl.xpm"
#include "pixmaps/spdritem_twr.xpm" //drw
#include "pixmaps/spdritem_twl.xpm"
#include "pixmaps/spdritem_sl1.xpm" //ekl
#include "pixmaps/spdritem_sl3.xpm"
#include "pixmaps/spdritem_sr1.xpm" //ekr
#include "pixmaps/spdritem_sr3.xpm"
#include "pixmaps/spdritem_dkl.xpm"
#include "pixmaps/spdritem_dkr.xpm"

/*signal panels */
#include "pixmaps/spdritem_hsl.xpm"
#include "pixmaps/spdritem_hsr.xpm"
#include "pixmaps/spdritem_hssl.xpm"
#include "pixmaps/spdritem_hssr.xpm"
#include "pixmaps/spdritem_rbl.xpm"
#include "pixmaps/spdritem_rbr.xpm"
#include "pixmaps/spdritem_sbl.xpm"
#include "pixmaps/spdritem_sbr.xpm"
#include "pixmaps/spdritem_sdl.xpm"
#include "pixmaps/spdritem_sdr.xpm"
#include "pixmaps/spdritem_shl.xpm"
#include "pixmaps/spdritem_shr.xpm"
#include "pixmaps/spdritem_ssl.xpm"
#include "pixmaps/spdritem_ssr.xpm"
#include "pixmaps/spdritem_vsl.xpm"
#include "pixmaps/spdritem_vsr.xpm"
#include "pixmaps/spdritem_wsl.xpm"
#include "pixmaps/spdritem_wsr.xpm"
#include "pixmaps/spdritem_zpl.xpm"
#include "pixmaps/spdritem_zpr.xpm"

/*miscellanous panels*/
#include "pixmaps/spdritem_adr.xpm"
#include "pixmaps/spdritem_bld.xpm"
#include "pixmaps/spdritem_dco.xpm"
#include "pixmaps/spdritem_lcr.xpm"
#include "pixmaps/spdritem_mdc.xpm"
#include "pixmaps/spdritem_rel.xpm"
#include "pixmaps/spdritem_tnt.xpm"
#include "pixmaps/spdritem_trt.xpm"

/*decorative panels*/
#include "pixmaps/spdritem_bs1.xpm"
#include "pixmaps/spdritem_bs2.xpm"
#include "pixmaps/spdritem_bs3.xpm"
#include "pixmaps/spdritem_bs4.xpm"
#include "pixmaps/spdritem_buc.xpm"
#include "pixmaps/spdritem_bul.xpm"
#include "pixmaps/spdritem_bur.xpm"
#include "pixmaps/spdritem_txt.xpm"
#include "pixmaps/spdritem_ltr.xpm" //sht
#include "pixmaps/spdritem_ltl.xpm"
#include "pixmaps/spdritem_lbr.xpm" //shb
#include "pixmaps/spdritem_lbl.xpm"
#include "pixmaps/spdritem_lsl.xpm"
#include "pixmaps/spdritem_lsr.xpm"

/*external group panels*/
#include "pixmaps/spdritem_feb.xpm"
#include "pixmaps/spdritem_fee.xpm"
#include "pixmaps/spdritem_feg.xpm"
#include "pixmaps/spdritem_fen.xpm"
#include "pixmaps/spdritem_fer.xpm"
#include "pixmaps/spdritem_fey.xpm"
#include "pixmaps/spdritem_taf.xpm"
#include "pixmaps/spdritem_tas.xpm"
#include "pixmaps/spdritem_tau.xpm"
#include "pixmaps/spdritem_taw.xpm"
#include "pixmaps/spdritem_twh.xpm"
#include "pixmaps/spdritem_tal.xpm"


PaintItemWindow::PaintItemWindow(QWidget* parent, const char* name)
: QDockWidget(tr("Paint items"), parent)
{
    setObjectName(name);
    setFeatures(QDockWidget::DockWidgetClosable
            | QDockWidget::DockWidgetMovable
            | QDockWidget::DockWidgetFloatable);

    setAllowedAreas(Qt::LeftDockWidgetArea | Qt::RightDockWidgetArea);
    setEnabled(false);

    QWidget* buttoncontainer = new QWidget(this);
    setWidget(buttoncontainer);

    QVBoxLayout* baseLayout = new QVBoxLayout(buttoncontainer);
    baseLayout->setSpacing(0);
    baseLayout->setMargin(0);

    QGridLayout* layout = new QGridLayout();
    layout->setSpacing(0);
    layout->setMargin(0);

    baseLayout->addLayout(layout);
    baseLayout->addStretch();

    paintItemBG = new QButtonGroup(this);
    Q_CHECK_PTR(paintItemBG);
    paintItemBG->setExclusive(true);

    /*straight track panels*/
    PaintItemButton* pib;
    pib = new PaintItemButton(QPixmap(spdritem_trh_xpm),
            tr("Horizontal track"),
            SpdrPanel::siciSt1, this, "horizontaltrackPanel");
    pib->setChecked(true);
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 0 , 0);

    pib = new PaintItemButton(QPixmap(spdritem_trv_xpm),
            tr("Vertical track"),
            SpdrPanel::siciSt2, this, "verticaltrackPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 0 , 1);

    pib = new PaintItemButton(QPixmap(spdritem_dil_xpm),
            tr("Left diagonal track"),
            SpdrPanel::siciSt4, this, "leftdiaPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 0 , 2);

    pib = new PaintItemButton(QPixmap(spdritem_dir_xpm),
            tr("Right diagonal track"),
            SpdrPanel::siciSt3, this, "rightdiaPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 0 , 3);

    pib = new PaintItemButton(QPixmap(spdritem_krr_xpm),
            tr("Right crossing"),
            SpdrPanel::siciKr1, this, "rightcrossingPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 0 , 4);

    pib = new PaintItemButton(QPixmap(spdritem_krl_xpm),
            tr("Left crossing"),
            SpdrPanel::siciKl1, this, "leftcrossingPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 0 , 5);

    pib = new PaintItemButton(QPixmap(spdritem_krh_xpm),
            tr("Diagonal crossing"),
            SpdrPanel::siciKrh, this, "crossingPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 0 , 6);

    pib = new PaintItemButton(QPixmap(spdritem_tdb_xpm),
            tr("Double direction track"),
            SpdrPanel::siciTdb, this, "bothdirectionPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 0 , 7);

    pib = new PaintItemButton(QPixmap(spdritem_tdr_xpm),
            tr("Single direction track right"),
            SpdrPanel::siciTdr, this, "rightdirectionPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 1 , 0);

    pib = new PaintItemButton(QPixmap(spdritem_tdl_xpm),
            tr("Single direction track left"),
            SpdrPanel::siciTdl, this, "leftdirectionPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 1 , 1);

    pib = new PaintItemButton(QPixmap(spdritem_tuv_xpm),
            tr("Vertical Tunnel"),
            SpdrPanel::siciTuv, this, "tunnelverticalPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 1 , 2);

    pib = new PaintItemButton(QPixmap(spdritem_tuh_xpm),
            tr("Horizontal Tunnel"),
            SpdrPanel::siciTuh, this, "tunnelhorizontalPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 1 , 3);

    pib = new PaintItemButton(QPixmap(spdritem_tul_xpm),
            tr("Diagonal tunnel left"),
            SpdrPanel::siciTul, this, "diagonaltunnelleftPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 1 , 4);

    pib = new PaintItemButton(QPixmap(spdritem_tur_xpm),
            tr("Diagonal tunnel right"),
            SpdrPanel::siciTur, this, "diagonaltunnelrightPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 1 , 5);

    /*curved track panels*/
    pib = new PaintItemButton(QPixmap(spdritem_cr1_xpm),
            tr("Curve right bottom"),
            SpdrPanel::siciCr1, this, "curveright1Panel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 1 , 6);

    pib = new PaintItemButton(QPixmap(spdritem_cl1_xpm),
            tr("Curve left top"),
            SpdrPanel::siciCl1, this, "curveleft1Panel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 1 , 7);

    pib = new PaintItemButton(QPixmap(spdritem_cr3_xpm),
            tr("Curve right top"),
            SpdrPanel::siciCr3, this, "curveright3Panel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 2 , 0);

    pib = new PaintItemButton(QPixmap(spdritem_cl3_xpm),
            tr("Curve left bottom"),
            SpdrPanel::siciCl3, this, "curveleft3Panel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 2 , 1);

    pib = new PaintItemButton(QPixmap(spdritem_cl2_xpm),
            tr("Curve top vertical left"),
            SpdrPanel::siciCl2, this, "curveleft2Panel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 2 , 2);

    pib = new PaintItemButton(QPixmap(spdritem_cr2_xpm),
            tr("Curve top vertical right"),
            SpdrPanel::siciCr2, this, "curveright2Panel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 2 , 3);

    pib = new PaintItemButton(QPixmap(spdritem_cr4_xpm),
            tr("Curve bottom vertical right"),
            SpdrPanel::siciCr4, this, "curveright4Panel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 2 , 4);

    pib = new PaintItemButton(QPixmap(spdritem_cl4_xpm),
            tr("Curve bottom vertical left"),
            SpdrPanel::siciCl4, this, "curveleft4Panel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 2 , 5);

    /*switch panels */
    pib = new PaintItemButton(QPixmap(spdritem_tl1_xpm),
            tr("Switch top left"),
            SpdrPanel::siciTl1, this, "turnoutleft1Panel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 2 , 6);

    pib = new PaintItemButton(QPixmap(spdritem_tr1_xpm),
            tr("Switch bottom right"),
            SpdrPanel::siciTr1, this, "turnoutright1Panel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 2 , 7);

    pib = new PaintItemButton(QPixmap(spdritem_tr3_xpm),
            tr("Switch top right"),
            SpdrPanel::siciTr3, this, "turnoutright3Panel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 3 , 0);

    pib = new PaintItemButton(QPixmap(spdritem_tl3_xpm),
            tr("Switch bottom left"),
            SpdrPanel::siciTl3, this, "turnoutleft3Panel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 3 , 1);

    pib = new PaintItemButton(QPixmap(spdritem_dtr_xpm),
            tr("Diagonal switch top right"),
            SpdrPanel::siciIr1, this, "diaswitchtoprightPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 3 , 2);

    pib = new PaintItemButton(QPixmap(spdritem_dbl_xpm),
            tr("Diagonal switch bottom left"),
            SpdrPanel::siciIl1, this, "diagswitchbotleftPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 3 , 3);

    pib = new PaintItemButton(QPixmap(spdritem_dtl_xpm),
            tr("Diagonal switch top left"),
            SpdrPanel::siciIl3, this, "diagswitchtopleftPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 3 , 4);

    pib = new PaintItemButton(QPixmap(spdritem_dbr_xpm),
            tr("Diagonal switch bottom right"),
            SpdrPanel::siciIr3, this, "diagswitchbotrightPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 3 , 5);

    pib = new PaintItemButton(QPixmap(spdritem_syr_xpm),
            tr("Y-Switch right"),
            SpdrPanel::siciSy1, this, "yswitchrightPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 3 , 6);

    pib = new PaintItemButton(QPixmap(spdritem_syl_xpm),
            tr("Y-Switch left"),
            SpdrPanel::siciSy3, this, "yswitchleftPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 3 , 7);

    pib = new PaintItemButton(QPixmap(spdritem_twr_xpm),
            tr("Three way turnout right"),
            SpdrPanel::siciTw1, this, "treewayrightPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 4 , 0);

    pib = new PaintItemButton(QPixmap(spdritem_twl_xpm),
            tr("Three way turnout left"),
            SpdrPanel::siciTw3, this, "threewayleftPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 4 , 1);

    pib = new PaintItemButton(QPixmap(spdritem_sl1_xpm),
            tr("Single-slip switch top left"),
            SpdrPanel::siciSl1, this, "singleslipleft1Panel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 4 , 2);

    pib = new PaintItemButton(QPixmap(spdritem_sl3_xpm),
            tr("Single-slip switch bottom left"),
            SpdrPanel::siciSl3, this, "singleslipleft3Panel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 4 , 3);

    pib = new PaintItemButton(QPixmap(spdritem_sr1_xpm),
            tr("Single-slip switch top right"),
            SpdrPanel::siciSr1, this, "singleslipright1Panel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 4 , 4);

    pib = new PaintItemButton(QPixmap(spdritem_sr3_xpm),
            tr("Single-slip switch bottom right"),
            SpdrPanel::siciSr3, this, "singleslipright3Panel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 4 , 5);

    pib = new PaintItemButton(QPixmap(spdritem_dkl_xpm),
            tr("Double-slip switch left"),
            SpdrPanel::siciDl1, this, "doubleleftPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 4 , 6);

    pib = new PaintItemButton(QPixmap(spdritem_dkr_xpm),
            tr("Double-slip switch right"),
            SpdrPanel::siciDr1, this, "doublerightPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 4 , 7);

    /*signal panels */
    pib = new PaintItemButton(QPixmap(spdritem_hsl_xpm),
            tr("Main signal left panel"),
            SpdrPanel::siciHs3, this, "mainsignalleftPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 5 , 0);

    pib = new PaintItemButton(QPixmap(spdritem_hsr_xpm),
            tr("Main signal right panel"),
            SpdrPanel::siciHs1, this, "mainsignalrightPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 5 , 1);

    pib = new PaintItemButton(QPixmap(spdritem_hssl_xpm),
            tr("Left main four state signal panel"),
            SpdrPanel::siciHss3, this, "leftmainfourstatesignalPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 5 , 2);

    pib = new PaintItemButton(QPixmap(spdritem_hssr_xpm),
            tr("Right main four state signal panel"),
            SpdrPanel::siciHss1, this, "rightmainfourstatesignalPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 5 , 3);

    pib = new PaintItemButton(QPixmap(spdritem_ssl_xpm),
            tr("Left shunt signal panel"),
            SpdrPanel::siciSs3, this, "leftshuntsignalPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 5 , 4);

    pib = new PaintItemButton(QPixmap(spdritem_ssr_xpm),
            tr("Right shunt signal panel"),
            SpdrPanel::siciSs1, this, "rightshuntsignalPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 5 , 5);

    pib = new PaintItemButton(QPixmap(spdritem_shl_xpm),
            tr("Left help route signal panel"),
            SpdrPanel::siciSh3, this, "helproutePanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 5 , 6);

    pib = new PaintItemButton(QPixmap(spdritem_shr_xpm),
            tr("Right help route signal panel"),
            SpdrPanel::siciSh1, this, "helproutePanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 5 , 7);

    pib = new PaintItemButton(QPixmap(spdritem_sdl_xpm),
            tr("Left double button shunt signal panel"),
            SpdrPanel::siciSd3, this, "lefttwobtnshuntsignalPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 6 , 0);

    pib = new PaintItemButton(QPixmap(spdritem_sdr_xpm),
            tr("Right doouble button shunt signal panel"),
            SpdrPanel::siciSd1, this, "righttwobtnshuntsignalPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 6 , 1);

    pib = new PaintItemButton(QPixmap(spdritem_wsl_xpm),
            tr("Left wait signal panel"),
            SpdrPanel::siciWs3, this, "leftwaitsignalPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 6 , 2);

    pib = new PaintItemButton(QPixmap(spdritem_wsr_xpm),
            tr("Right wait signal panel"),
            SpdrPanel::siciWs1, this, "RightwaitsignalPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 6 , 3);

    pib = new PaintItemButton(QPixmap(spdritem_rbl_xpm),
            tr("Left route button panel"),
            SpdrPanel::siciZt3, this, "leftroutebuttonPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 6 , 4);

    pib = new PaintItemButton(QPixmap(spdritem_rbr_xpm),
            tr("Right route button panel"),
            SpdrPanel::siciZt1, this, "rightroutebuttonPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 6 , 5);

    pib = new PaintItemButton(QPixmap(spdritem_sbl_xpm),
            tr("Left shunt button panel"),
            SpdrPanel::siciRt3, this, "leftshuntbuttonPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 6 , 6);

    pib = new PaintItemButton(QPixmap(spdritem_sbr_xpm),
            tr("Right shunt button panel"),
            SpdrPanel::siciRt1, this, "rightshuntbuttonPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 6 , 7);

    pib = new PaintItemButton(QPixmap(spdritem_vsl_xpm),
            tr("Left distant signal panel"),
            SpdrPanel::siciVs3, this, "leftdistantsignalPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 7 , 0);

    pib = new PaintItemButton(QPixmap(spdritem_vsr_xpm),
            tr("Right distant signal panel"),
            SpdrPanel::siciVs1, this, "rightdistantsignalPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 7 , 1);

    pib = new PaintItemButton(QPixmap(spdritem_zpl_xpm),
            tr("Left ZP signal panel"),
            SpdrPanel::siciZp3, this, "leftzpsignalPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 7 , 2);

    pib = new PaintItemButton(QPixmap(spdritem_zpr_xpm),
            tr("Right ZP signal panel"),
            SpdrPanel::siciZp1, this, "rightzpsignalPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 7 , 3);

    /*miscellanous panels*/
    pib = new PaintItemButton(QPixmap(spdritem_dco_xpm),
            tr("Decoupler"),
            SpdrPanel::siciEnk, this, "decouplerPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 7 , 4);

    pib = new PaintItemButton(QPixmap(spdritem_bld_xpm),
            tr("Blind element"),
            SpdrPanel::siciBld, this, "blindPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 7 , 5);

    pib = new PaintItemButton(QPixmap(spdritem_adr_xpm),
            tr("Address indicator"),
            SpdrPanel::siciAdr, this, "addressPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 7 , 6);

    pib = new PaintItemButton(QPixmap(spdritem_lcr_xpm),
            tr("Level crossing"),
            SpdrPanel::siciBue, this, "levelcrossingPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 7 , 7);

    pib = new PaintItemButton(QPixmap(spdritem_rel_xpm),
            tr("Relais"),
            SpdrPanel::siciRel, this, "relaisPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 8 , 0);

    pib = new PaintItemButton(QPixmap(spdritem_mdc_xpm),
            tr("DC motor"),
            SpdrPanel::siciMdc, this, "dcmotorPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 8 , 1);

    pib = new PaintItemButton(QPixmap(spdritem_tnt_xpm),
            tr("Turntable"),
            SpdrPanel::siciDre, this, "turntablePanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 8 , 2);

    pib = new PaintItemButton(QPixmap(spdritem_trt_xpm),
            tr("Transfer table"),
            SpdrPanel::siciSbn, this, "transfertablePanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 8 , 3);

    /*decorative panels*/
    pib = new PaintItemButton(QPixmap(spdritem_bs1_xpm),
            tr("Right buffer stop"),
            SpdrPanel::siciBs1, this, "bufferstop1Panel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 8 , 4);

    pib = new PaintItemButton(QPixmap(spdritem_bs2_xpm),
            tr("Top buffer stop"),
            SpdrPanel::siciBs2, this, "bufferstop2Panel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 8 , 5);

    pib = new PaintItemButton(QPixmap(spdritem_bs3_xpm),
            tr("Left buffer stop"),
            SpdrPanel::siciBs3, this, "bufferstop3Panel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 8 , 6);

    pib = new PaintItemButton(QPixmap(spdritem_bs4_xpm),
            tr("Bottom buffer stop"),
            SpdrPanel::siciBs4, this, "bufferstop4Panel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 8 , 7);

    pib = new PaintItemButton(QPixmap(spdritem_txt_xpm),
            tr("Text field panel"),
            SpdrPanel::siciTxt, this, "textfieldPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 9 , 0);

    pib = new PaintItemButton(QPixmap(spdritem_buc_xpm),
            tr("House center wing"),
            SpdrPanel::siciBuc, this, "centerwingPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 9 , 1);

    pib = new PaintItemButton(QPixmap(spdritem_bul_xpm),
            tr("Building left wing"),
            SpdrPanel::siciBul, this, "buildingleftwingPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 9 , 2);

    pib = new PaintItemButton(QPixmap(spdritem_bur_xpm),
            tr("Building right wing"),
            SpdrPanel::siciBur, this, "buildingrightwingPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 9 , 3);

    pib = new PaintItemButton(QPixmap(spdritem_ltr_xpm),
            tr("Top right loco shed"),
            SpdrPanel::siciLt1, this, "locoshedtrPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 9 , 4);

    pib = new PaintItemButton(QPixmap(spdritem_lbr_xpm),
            tr("Bottom right loco shed"),
            SpdrPanel::siciLb1, this, "locoshedbrPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 9 , 5);

    pib = new PaintItemButton(QPixmap(spdritem_lsr_xpm),
            tr("Middle loco shed right"),
            SpdrPanel::siciLs1, this, "locoshedmrightPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 9 , 6);

    pib = new PaintItemButton(QPixmap(spdritem_lsl_xpm),
            tr("Middle loco shed left"),
            SpdrPanel::siciLs3, this, "locoshedmleftPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 9 , 7);

    pib = new PaintItemButton(QPixmap(spdritem_ltl_xpm),
            tr("Top left loco shed"),
            SpdrPanel::siciLt3, this, "locoshedtlPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 10 , 0);

    pib = new PaintItemButton(QPixmap(spdritem_lbl_xpm),
            tr("Bottom left loco shed"),
            SpdrPanel::siciLb3, this, "locoshedblPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 10 , 1);

    /*external group panels*/
    pib = new PaintItemButton(QPixmap(spdritem_feg_xpm),
            tr("Route group panel"),
            SpdrPanel::siciFeg, this, "routePanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 10 , 2);

    pib = new PaintItemButton(QPixmap(spdritem_taf_xpm),
            tr("FHT panel"),
            SpdrPanel::siciTaf, this, "fhtPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 10 , 3);

    pib = new PaintItemButton(QPixmap(spdritem_tau_xpm),
            tr("UfGT and MGT panel"),
            SpdrPanel::siciTau, this, "ufgtPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 10 , 4);

    pib = new PaintItemButton(QPixmap(spdritem_feb_xpm),
            tr("Turnout group panel"),
            SpdrPanel::siciFeb, this, "turnoutPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 10 , 5);

    pib = new PaintItemButton(QPixmap(spdritem_taw_xpm),
            tr("WGT panel"),
            SpdrPanel::siciTaw, this, "wgtPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 10 , 6);

    pib = new PaintItemButton(QPixmap(spdritem_twh_xpm),
            tr("WHT panel"),
            SpdrPanel::siciTwh, this, "whtPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 10 , 7);

    pib = new PaintItemButton(QPixmap(spdritem_fer_xpm),
            tr("Signal group panel"),
            SpdrPanel::siciFer, this, "signalPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 11 , 0);

    pib = new PaintItemButton(QPixmap(spdritem_tas_xpm),
            tr("SGT and HaGT panel"),
            SpdrPanel::siciTas, this, "sgtPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 11 , 1);

    pib = new PaintItemButton(QPixmap(spdritem_fey_xpm),
            tr("Level crossing group panel"),
            SpdrPanel::siciFey, this, "crossingPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 11 , 2);

    pib = new PaintItemButton(QPixmap(spdritem_fen_xpm),
            tr("Axle counter group panel"),
            SpdrPanel::siciFen, this, "axlePanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 11 , 3);

    pib = new PaintItemButton(QPixmap(spdritem_fee_xpm),
            tr("Power supply group panel"),
            SpdrPanel::siciFee, this, "powerPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 11 , 4);

    pib = new PaintItemButton(QPixmap(spdritem_tal_xpm),
            tr("Table light panel"),
            SpdrPanel::siciTal, this, "lightPanel");
    paintItemBG->addButton(pib);
    layout->addWidget(pib, 11 , 5);

    connect(paintItemBG, SIGNAL(buttonPressed(QAbstractButton*)),
            this, SLOT(paintItemPressed(QAbstractButton*)));
}

/*
 * translate selected button to a public paint item value
 */
void PaintItemWindow::paintItemPressed(QAbstractButton* pib)
{
    if (pib == NULL)
        return;

    emit paintItemChanged(static_cast<PaintItemButton*>(pib)->Sici());
}

/*
 * disable/enable paint items
 */
void PaintItemWindow::changeLayoutEditMode(GBSArea::LayoutEditMode mode)
{
    setEnabled(mode == GBSArea::lemPaint);
}
